<?php
/* $Id: nc_comments_admin.class.php 3763 2010-04-30 11:51:43Z denis $ */

class nc_comments_admin {
  
  protected $db, $UI_CONFIG, $ADMIN_TEMPLATE;
  
  public function __construct () {
    // global variables
    global $db, $UI_CONFIG, $ADMIN_TEMPLATE, $MODULE_FOLDER;
    
    // global variables to internal
    $this->db = &$db;
    $this->UI_CONFIG = $UI_CONFIG;
    $this->ADMIN_TEMPLATE = $ADMIN_TEMPLATE;
    $this->MODULE_FOLDER = $MODULE_FOLDER;
    // superglobal variable
    $this->POST = $_POST;
  
    // this function must be called only from cache/admin.php file
    $debug_backtrace = debug_backtrace();
    // get file from calling this method
    $deb_value = $debug_backtrace[0];
    // validate file permission
    /*if (
      !( str_replace( array("/", "\\"), "/", $deb_value['file']) == str_replace( array("/", "\\"), "/", $this->MODULE_FOLDER."comments/admin.php") )
    ) {
      throw new Exception (NETCAT_MODULE_COMMENTS_CLASS_UNRECOGNIZED_OBJECT_CALLING);
    }*/
    
    return;
  }
  
  public function converter ($phase = 3, $catalogue = 0, $subdivision = 0) {
    
    $catalogue = intval($catalogue);
    $subdivision = intval($subdivision);
    
    $error = false;
    
    if ( ($phase==4 && !$catalogue) || ($phase==5 && !$subdivision) ) $phase--;
    
    echo "<form method='post' action='admin.php' id='ConvertComments' style='padding:0; margin:0;'>\n".
      "<input type='hidden' name='phase' value='".($phase + 1)."'>\n".
      "<input type='hidden' name='page' value='converter'>\n".
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_CONVERTER_DIALOG."</font></b>\n";
			      
      if ($phase==3) {
        $catalogues = $this->db->get_results("SELECT `Catalogue_ID`, `Catalogue_Name` FROM `Catalogue`", ARRAY_A);
        if ( !empty($catalogues) ) {
          echo "<div style='padding:10px 0 5px'>".
          "<font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_CONVERTER_SELECT_CATALOGUE."</font><br>".
          "<select name='ConverterCatalogue' style='width:50%'>";
  				foreach($catalogues AS $value) {
  					echo "<option value='".$value['Catalogue_ID']."'>".$value['Catalogue_Name']."</option>";
  				}
          echo "</select>";
        }
        else {
          nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_NO_CATALOGUE_ERROR, "error");
          $error = true;
        }
      }
      
      if ($phase==4) {
        $subdivisions = $this->db->get_results("SELECT `Subdivision_ID` AS value,
          CONCAT(`Subdivision_ID`, '. ', `Subdivision_Name`) AS description, `Parent_Sub_ID` AS parent
          FROM `Subdivision`
          WHERE `Catalogue_ID` = '".$catalogue."'
          ORDER BY `Subdivision_ID`", ARRAY_A);
        if ( !empty($subdivisions) ) {
          echo "<div style='padding:10px 0 5px'>".
          "<font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_CONVERTER_SELECT_SUBDIVISION."</font><br>".
          "<input type='hidden' name='ConverterCatalogue' value='".$catalogue."'>".
          "<select name='ConverterSubdivision' style='width:50%'>";
  				echo nc_select_options($subdivisions);
          echo "</select>";
        }
        else {
          nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_NO_SUBDIVISION, "info");
          $error = true;
        }
      }
      
      if ($phase==5) {
        $subclasses = $this->db->get_results("SELECT `Sub_Class_ID`, `Sub_Class_Name`
          FROM `Sub_Class`
          WHERE `Subdivision_ID` = '".$subdivision."'
          ORDER BY `Sub_Class_ID`", ARRAY_A);
        if ( !empty($subclasses) ) {
          echo "<div style='padding:10px 0 5px'>".
          "<font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_CONVERTER_SELECT_SUBCLASS."</font><br>".
          "<input type='hidden' name='ConverterCatalogue' value='".$catalogue."'>".
          "<input type='hidden' name='ConverterSubdivision' value='".$subdivision."'>".
          "<select name='ConverterSubClass' style='width:50%'>";
  				foreach($subclasses AS $value) {
  					echo "<option value='".$value['Sub_Class_ID']."'>".$value['Sub_Class_Name']."</option>";
  				}
          echo "</select>";
        }
        else {
          nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_NO_SUBCLASS, "info");
          $error = true;
        }
      }
      
      echo "</legend>\n".
        "</fieldset><br/>\n";
    
    // admin buttons
    if (!$error) {
    	$this->UI_CONFIG->actionButtons[] = array(
        "id" => "submit",
        "caption" => constant("NETCAT_MODULE_COMMENTS_ADMIN_CONVERTER_SAVE_BUTTON_".$phase),
        "action" => "mainView.submitIframeForm('ConvertComments')"
      );
    }
    else {
      $this->UI_CONFIG->actionButtons[] = array(
        "id" => "submit",
        "caption" => NETCAT_MODULE_COMMENTS_ADMIN_CONVERTER_RETURN_BUTTON,
        "location" => "module.comments.converter(3)"
      );
    }
  	
    echo "</form><br/>\n";
    
    return;
  }
  
  public function converterSave () {
   
    $catalogue = intval($_POST['ConverterCatalogue']);
    $subdivision = intval($_POST['ConverterSubdivision']);
    $subclass = intval($_POST['ConverterSubClass']);
    
    if (!$catalogue && !$subdivision && !$subclass) {
      //  
      nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_DATA_ERROR, "error");
      return false;
    }
    
    $classid = $this->db->get_var("SELECT `Class_ID` FROM `Sub_Class` WHERE `Sub_Class_ID` = '".$subclass."'");
    
    if (!$classid) {
      //  
      nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_CLASS_ERROR, "error");
      return false;
    }
    
    //  
    $error = false;
    
    $fields = array(
      "Object_Sub_Class_ID" => "Sub_Class_ID",
      "Object_ID" => "Message_ID",
      "Object_Parent_ID" => "Parent_Comment_ID",
      "Created" => array("Date", "Updated"),
      "Message" => "Comment",
      "User_ID" => "User_ID"
    );
       
    //     MessageXX  Comments_Text   ID
    $converted_ids = nc_copy_data("Message".$classid, "Comments_Text", $fields, true, "`Sub_Class_ID` = '".$subclass."'");
   
    if ( !empty($converted_ids) ) {
      //     ID  - 
      $parent_relation = array();
      
      //     ID   Comments_text
      $children = $this->db->get_results("SELECT m.`Object_Parent_ID` AS old_parent, c.`id` AS children_with_old_parent 
        FROM `Message".$classid."` AS m
        LEFT JOIN `Comments_Text` AS c ON m.`Object_ID` = c.`Message_ID`
          AND m.`Object_Sub_Class_ID` = c.`Sub_Class_ID`
          AND m.`Object_Parent_ID` = c.`Parent_Comment_ID`
        WHERE m.`Object_Parent_ID` > 0 AND c.`id` IN (".join(",", $converted_ids).")", ARRAY_A);
      
      $old_parent = array();
      //$children_with_old_parent = array();    
      if ( !empty($children) ) {
        foreach ($children as $value) {
          $old_parent[] = $value['old_parent'];
          //$children_with_old_parent[] = $value['children_with_old_parent'];
        }
      }
      
      if ( !empty($old_parent) ) {
        //   ID   MessageXX    ID  Comments_Text
        $parents = $this->db->get_results("SELECT m.`Message_ID` AS old_parent_id, c.`id` AS new_parent_id
          FROM `Message".$classid."` AS m
          LEFT JOIN `Comments_Text` AS c ON m.`Object_ID` = c.`Message_ID`
            AND m.`Object_Sub_Class_ID` = c.`Sub_Class_ID`
            AND m.`Object_Parent_ID` = c.`Parent_Comment_ID`
            AND m.`Message` = c.`Comment`
            AND m.`Created` = c.`Date`
            AND m.`User_ID` = c.`User_ID`
          WHERE m.`Message_ID` IN (".join(",", $old_parent).")", ARRAY_A);
        
        if ( count($old_parent)==count($parents) ) {
          
          if ( !empty($parents) ) {
            // :  ID  MessageXX =>  ID  Comments_Text
            foreach ($parents as $value) {
              $parent_relation[ $value['old_parent_id'] ] = $value['new_parent_id'];
            }
          }
          
          foreach ($children as $value) {
            //  Parent  
            $new_parent = $parent_relation[ $value['old_parent'] ];
            //  
            $this->db->query("UPDATE `Comments_Text`
              SET `Parent_Comment_ID` = '".$new_parent."'
              WHERE `id` = '".$value['children_with_old_parent']."'");
          }
          
        }
        else {
          //    ,      
          nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_PARENT_ERROR, "error");
          //  ,     
          $this->db->query("DELETE FROM `Comments_Text` WHERE `id` IN (".join(",", $converted_ids).")");
          //  
          $error = true;
        }
      }
      // count comments and replies
      $this->optimizeSave();
    }
    else {
      //  
      nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_NO_DATA, "info");
      //  
      $error = true;
    }
    
    return !$error;
  }
  
  public function optimize () {
    
    echo "<form method='post' id='DoOptimize' action='admin.php' style='padding:0; margin:0;'>\n".
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_OPTIMIZE."</font></b>\n".
      "</legend>\n".
      // use default
      "<div style='margin:10px 0; _padding:0;'>\n".
      "<input type='checkbox' name='OptimizeComments' value='1'/> ".NETCAT_MODULE_COMMENTS_ADMIN_OPTIMIZE_DO.
      "</div>\n".
      "</fieldset><br/>\n";
    
    // admin buttons
  	$this->UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_COMMENTS_ADMIN_OPTIMIZE_DO_BUTTON,
      "action" => "mainView.submitIframeForm('DoOptimize')"
    );
  	
    echo "<input type='hidden' name='phase' value='8'>\n".
      "<input type='hidden' name='page' value='optimize'>\n".
      "</form><br/>\n";
    
    return;
  }
  
  
  public function optimizeSave () {
    // get counted data
    $data = $this->db->get_results("SELECT COUNT(`id`) AS Total, COUNT( IF(`Parent_Comment_ID`, 1, NULL) ) AS Replies, `Sub_Class_ID`, `Message_ID`
      FROM `Comments_Text`
      GROUP BY `Sub_Class_ID`, `Message_ID`", ARRAY_A);
      
    if ( empty($data) ) return false;
    
    // clear table with old counted data
    $this->db->query("TRUNCATE TABLE `Comments_Count`");
    
    $i = 0;
    foreach ($data as $value) {
      // insert counted row data
      $this->db->query("INSERT INTO `Comments_Count`
        (`Sub_Class_ID`, `Message_ID`, `CountComments`, `CountReplies`)
        VALUES
        ('".intval($value['Sub_Class_ID'])."', '".intval($value['Message_ID'])."', '".( intval($value['Total']) - intval($value['Replies']) )."', '".intval($value['Replies'])."')");
      if ($this->db->insert_id) $i++;
    }

    // return total inserted rows
    return $i;
  }
  
  public function settings () {
    
    $Template = $this->POST['Template'];
    
    $TemplatesData = $this->db->get_results("SELECT * FROM `Comments_Settings`", ARRAY_A);
    
    $default = array();
    $settings = array();
    
    if ( !empty($TemplatesData) ) {
      foreach ($TemplatesData AS $value) {
        if ($value['Default']) $default = $value;
        if ($value['ID']!=$Template) continue;
        $settings = $value;
      }
      if ( $Template!="new" ) {
        if ( empty($settings) && !empty($default) ) $settings = $default;
        if ( empty($settings) ) $settings = $TemplatesData[0];
      }
    }
    
    if (!$Template) $Template = $settings['ID'];

    echo "<form method='post' action='admin.php' style='padding:0; margin:0;'>\n".
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_MAINSETTINGS_TEMPLATE."</font></b>\n".
      "</legend>\n".
      "<div style='margin:10px 0; _padding:0;'>\n".
      "<select name='Template' onchange='this.form.submit();' style='width:50%'>\n";
  		if ( !empty($TemplatesData) ) {
        foreach($TemplatesData AS $value) {
          echo "<option value='".$value['ID']."' ".($value['ID']==$Template && $Template!="new" ? "selected" : "").">".$value['ID'].": ".$value['Name']."</option>\n";
        }
      }
      echo "<option value='new'".( empty($TemplatesData) || $Template=="new" ? " selected" : "").">".NETCAT_MODULE_COMMENTS_ADMIN_MAINSETTINGS_TEMPLATE_NEW."</option>\n";
  	echo "</select>\n".
      "</div>\n".
      "</fieldset>\n".
      "</form><br/>\n";
      
    echo "<form method='post' action='admin.php' id='SetCommentsSettings' style='padding:0; margin:0;'>\n".
      "<input type='hidden' name='Template' value='".($Template && $Template!="new" ? $Template : 0)."'>".
      "<fieldset>\n".
      "<legend>\n".
  		"<b><font color='gray'>".NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS."</font></b>\n".
      "</legend>\n".
      // use default
      "<div style='margin:10px 0; _padding:0;'>\n".
      "<input type='checkbox' name='Default' value='1'".($settings['Default'] ? " checked" : "")."/> ".NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_USE_DEFAULT.
      " &nbsp; ".
      "<input type='checkbox' name='BBcodes' value='1'".($settings['BBcodes'] ? " checked" : "")."/> ".NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_USE_BBCODES.
      "</div>\n".
      // template name
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_NAME.":<br/>".
      "<input type='text' name='Name' style='width:100%' value='".$settings['Name']."'/>".
      "</div>\n".
      // wall prefix
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_PREFIX.":<br/>".
      "<textarea name='Prefix' style='width:100%; height:1.5em; line-height:1em'>".htmlentities($settings['Prefix'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // comments block
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_COMMENT_BLOCK.":<br/>".
      "<textarea name='Comment_Block' style='width:100%; height:7em; line-height:1em'>".htmlentities($settings['Comment_Block'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // reply block
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_REPLY_BLOCK.":<br/>".
      "<textarea name='Reply_Block' style='width:100%; height:7em; line-height:1em'>".htmlentities($settings['Reply_Block'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // comment link
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_LINK_COMMENT.":<br/>".
      "<textarea name='Comment_Link' style='width:100%; height:1.5em; line-height:1em'>".htmlentities($settings['Comment_Link'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // reply link
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_LINK_REPLY.":<br/>".
      "<textarea name='Reply_Link' style='width:100%; height:1.5em; line-height:1em'>".htmlentities($settings['Reply_Link'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // edit link
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_LINK_EDIT.":<br/>".
      "<textarea name='Edit_Link' style='width:100%; height:1.5em; line-height:1em'>".htmlentities($settings['Edit_Link'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // delete link
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_LINK_DROP.":<br/>".
      "<textarea name='Delete_Link' style='width:100%; height:1.5em; line-height:1em'>".htmlentities($settings['Delete_Link'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // add comments
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_APPEND_BLOCK.":<br/>".
      "<textarea name='Add_Block' style='width:100%; height:7em; line-height:1em'>".htmlentities($settings['Add_Block'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // edit comments
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_EDIT_BLOCK.":<br/>".
      "<textarea name='Edit_Block' style='width:100%; height:7em; line-height:1em'>".htmlentities($settings['Edit_Block'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // delete comments
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_DROP_BLOCK.":<br/>".
      "<textarea name='Delete_Block' style='width:100%; height:7em; line-height:1em'>".htmlentities($settings['Delete_Block'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
      // wall suffix
      "<div style='margin:10px 0; _padding:0;'>\n".
      NETCAT_MODULE_COMMENTS_ADMIN_TEMPLATE_SETTINGS_SUFFIX.":<br/>".
      "<textarea name='Suffix' style='width:100%; height:1.5em; line-height:1em'>".htmlentities($settings['Suffix'], ENT_COMPAT, MAIN_ENCODING)."</textarea>".
      "</div>\n".
            
      "</fieldset><br/>\n";
    
    // admin buttons
  	$this->UI_CONFIG->actionButtons[] = array(
      "id" => "submit",
      "caption" => NETCAT_MODULE_COMMENTS_ADMIN_MAINSETTINGS_SAVE_BUTTON,
      "action" => "mainView.submitIframeForm('SetCommentsSettings')"
    );
  	
    echo "<input type='hidden' name='phase' value='2'>\n".
      "</form><br/>\n";
    
    return;
  }


  public function settingsSave () {

    $Template = $this->POST['Template'];
    // simple check
    if ( !( is_numeric($Template) || $Template=="new" ) ) return false;
    
    $_fields = $this->db->get_col("SHOW COLUMNS FROM `Comments_Settings`");
    
    if ( !empty($_fields) && !empty($this->POST) ) {
      $default = false;
      $query_arr = array();
      foreach ($this->POST as $key => $value) {
        // only need fields
        if ( !in_array($key, $_fields) || $key=='ID' ) continue;
        // append to query array
        $query_arr[] = "`".$key."` = '".$this->db->escape($value)."'";
        // check default
        if ($key=="Default") $default = true;
      }
      if ( empty($query_arr) ) return false;
      // reset not posted fields
      if ( sizeof($_fields)!=sizeof($query_arr) ) {
        foreach ($_fields as $field_name) {
          if ( !in_array( $field_name, array_keys($this->POST) ) && $field_name!='ID' ) {
            $query_arr[] = "`".$field_name."` = DEFAULT(`".$field_name."`)";
          }
        }
      }
      // existence
      if ($Template!="new") $SettingsExist = $this->db->get_var("SELECT `ID` FROM `Comments_Settings` WHERE `ID` = '".intval($Template)."'");
      // clear default
      if ($default) $this->db->query("UPDATE `Comments_Settings` SET `Default` = DEFAULT(`Default`)");
      // save settings
      if ($Template && $Template!="new" && $SettingsExist) {
        $this->db->query("UPDATE `Comments_Settings` SET ".join(", ", $query_arr)." WHERE `ID` = '".intval($Template)."'");
      }
      else {
        $this->db->query("INSERT INTO `Comments_Settings` SET ".join(", ", $query_arr) );
      }
    }

    // return changes status
    return $this->db->rows_affected;
  }

}
?>