<?
require_once("Benchmark/Timer.php");

/**
 *    SQL-
 * 
 * @global $nc_core, $UI_CONFIG
 *
 */
function ShowSQLForm() {
  global $nc_core, $UI_CONFIG;  
  
  $db = $nc_core->db;
  $Query = $nc_core->input->fetch_post('Query');
   
  ?>
    
  <form action='index.php' method='post'>
    <div class='resize_block'>
      <a class='textarea_shrink' href='#Query' > &#x25BC; </a><a class='textarea_grow' href='#Query'> &#x25B2; </a>
    </div>
  <textarea wrap='off' rows='10' cols='60' name='Query' id='Query'><?=htmlspecialchars(stripslashes($Query))?></textarea>
  <br><br>
  <input type='hidden' name='phase' value='2'>
  </form>

  <!-- Binding event_handlers to textarea resize link -->
  <script>
    (function (){
      var links = document.getElementsByTagName("A");
      var onclicker_grow   = function (event) { ShrinkArea(event, 50);  }
      var onclicker_shrink = function (event) { ShrinkArea(event,-50);  }
      for (var i = 0 ; i < links.length ; i++){
          if (links[i].className.search('textarea_shrink') != -1 ) {
            bindEvent(links[i], 'click', onclicker_grow );
          }
          if (links[i].className.search('textarea_grow') != -1 ) {
            bindEvent(links[i], 'click', onclicker_shrink);
          }
      }
    }) ();
  </script>
  
  <?=TOOLS_SQL_HISTORY?>:
  <ul>
  <?
	
  $i=0;
	$history = $db->get_col("SELECT `SQL_text` FROM `SQLQueries` ORDER BY `SQL_ID` DESC");
	
	if ( !empty($history) ) {
		foreach ( $history as $query) {
			$i++;
      echo "<li><a href=# onclick=\"document.getElementById('Query').value=document.getElementById('query".$i."').value;return false;\">".htmlspecialchars($query,ENT_QUOTES)."</a><br><input type=hidden value='".htmlspecialchars($query,ENT_QUOTES)."' name=query".$i." id=query".$i."><br>";
		}
	}
  ?>
  
  </ul>
  <br>
  
  <?=TOOLS_SQL_HELP?>:
  <li><b>SHOW TABLES</b> - <?=TOOLS_SQL_HELP_SHOW?>
  <li><b>EXPLAIN `User`</b> - <? printf(TOOLS_SQL_HELP_EXPLAIN, "User"); ?>
  <li><b>SELECT COUNT(*) FROM `Subdivision`</b> -  <? printf(TOOLS_SQL_HELP_SELECT, "Subdivision"); ?>
  <br><br>
  
  <?=TOOLS_SQL_HELP_DOCS?>
  
  <?
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => TOOLS_SQL_SEND,
                                      "action" => "mainView.submitIframeForm()"
                                     ); 
  return 0;
}


/**
 *  sql-
 *
 * @param string 
 * 
 * @global $nc_core
 * 
 * @return bool    
 */
function ExecuteSQLQuery ($Query) {
  global $nc_core;
   
  $SHOW_MYSQL_ERRORS = $nc_core->SHOW_MYSQL_ERRORS;
  $db = $nc_core->db;
  // 
  $nccttimer = new Benchmark_Timer();
  
  $Query = trim(stripslashes($Query));
  
  //      15,   
	if ($db->get_var("SELECT COUNT(`SQL_ID`) FROM `SQLQueries`") >= 15 ) {
		$db->query("DELETE FROM `SQLQueries` ORDER BY `SQL_ID` LIMIT 1");
	}
	$db->query("INSERT INTO SQLQueries (SQL_ID, SQL_text) VALUES ('', '".$db->escape($Query)."')");

	//      ,      
	$db->hide_errors();
  //  
	$nccttimer->start();
  $res = $db->get_results(stripslashes($Query),ARRAY_A);
  $nccttimer->stop();
	
  //    MySQL ,    
	if ($SHOW_MYSQL_ERRORS=='on') $db->show_errors();
	
  if ($db->captured_errors) {
		echo "<b>Query:</b> ".$db->captured_errors[0][query]."<br><br><b>Error:</b> ".$db->captured_errors[0][error_str]."<br><br>";
    return false;
  }

			
	$count=$db->num_rows;

	//    ,   
	if ($res && $count ) {
		echo "<b>".htmlspecialchars(stripslashes($Query))."</b><br><br>";
    $data = $res;
    
    echo "<table border='0' cellpadding='0' cellspacing='0' width='100%'>
            <tr><td bgcolor='#CCCCCC'>
              <table border='0' cellpadding='5' cellspacing='1' width='100%'><tr>";
    
    // 
    while (list($key,$val)=each($res[0])) {
      echo "<td bgcolor='#EEEEEE'><font size='-2'>".$key."</td>";
    }
    echo "</tr>";
    
    reset($res[0]);

    for ( $i=0; $i<$count; $i++ ) {
      echo "<tr>";
      while (list($key,$val)=each($res[$i])) {
        echo "<td bgcolor='#FFFFFF'><font size='-2'>".htmlspecialchars($res[$i][$key])."</td>";
      }
      echo "</tr>";
    }
    
    echo "</table></td></tr></table><br>";

    $res_num = $count ? $count : $db->rows_affected;
		
    
	}
  elseif (!$res ) {
    if (preg_match("/^(insert|delete|update|replace)\s+/i",$db->last_query)) {
      $res_num = $db->rows_affected;
    }
    else {
      $res_num = $db->num_rows;
    }
	}
  
	echo TOOLS_SQL_OK."<br>";
  echo TOOLS_SQL_TOTROWS.": ".$res_num."<br>";
  echo TOOLS_SQL_BENCHMARK.": ".$nccttimer->timeElapsed();
  echo "<br><br>";
    
	return true;
}
?>