<?php
/* $Id: connect_io.php 3789 2010-05-06 11:22:55Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -2 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
// unset for security reasons
$SYSTEM_FOLDER = "";
// connect config file
@include_once ($NETCAT_FOLDER."vars.inc.php");

// if vars.inc.php not updated set default value for $SYSTEM_FOLDER
if (!$SYSTEM_FOLDER) {
  global $SYSTEM_FOLDER;
  $SYSTEM_FOLDER = $ROOT_FOLDER."system/";
}

// PHP version must be >= 5.1
if ( preg_match("/^(\d)\.(\d)/is", phpversion(), $matches) ) {
  if ( intval($matches[1].$matches[2]) < 51 ) die("<b style='color:#A00'>PHP 5.1 or higher required!</b>");
}

// short_open_tag must be on
if ( !ini_get('short_open_tag') ) {
  die("<b style='color:#A00'>short_open_tag value must be on!</b>");
}

// include all new system classes and get nc_core object
require_once ($SYSTEM_FOLDER."index.php");

// init db interface
try {
  // connect to database
  $nc_core->db->set_connect($MYSQL_DB_NAME, $MYSQL_USER, $MYSQL_PASSWORD, $MYSQL_HOST);
  // set db for compatibillity
  $db = $nc_core->db;
  // if MySQL tables not exist
  if ( !$db->get_var("SHOW TABLES LIKE 'Settings'") ) {
    if ( file_exists($DOCUMENT_ROOT.$SUB_FOLDER."/install/index.php") ) {
      header("Location: ".$SUB_FOLDER."/install/");
    }
    // nothing to do
    die("<b style='color:#A00'>System not installed!</b>");    
  }
}
catch (Exception $e) {
  // put into the log
  $nc_core->errorMessage($e);
  // show message
  die ( $e->getMessage() );
}

// what to do when with MySQL errors
if ($SHOW_MYSQL_ERRORS=="on") {
  $db->show_errors();
}
else {
  $db->hide_errors();
}

// link to object
$LinkID = &$db->dbh;

// set default names
if ( (float)mysql_get_server_info($LinkID) >= 4.1 ) {
  if (!$MYSQL_CHARSET) $MYSQL_CHARSET = 'cp1251';
  $db->query("SET NAMES '".$MYSQL_CHARSET."'");
  $db->query("SET sql_mode=''");
  if ( $MYSQL_TIMEZONE ) $db->query("SET TIME_ZONE = '".$MYSQL_TIMEZONE."'");
}

// encryption function
$MYSQL_ENCRYPT = strtoupper($MYSQL_ENCRYPT);
if ( !$MYSQL_ENCRYPT || !in_array($MYSQL_ENCRYPT, array('PASSWORD','OLD_PASSWORD','MD5','SHA','SHA1') ) ) {
  // for old version
  $MYSQL_ENCRYPT = 'PASSWORD';
}

// need to extract GLOBALS
include_once ($INCLUDE_FOLDER."s_extract.inc.php");

?>